<template>
    <theme-table :noneActions="true">
        <span slot="main-title">
            {{ $t('Not Closing Report') }}
        </span>
        <div slot="more-button">
            <button class="btn btn-secondary" type="button" data-bs-toggle="offcanvas" data-bs-target="#offcanvasRight"
                aria-controls="offcanvasRight">{{ $t('Filter') }}</button>
            <div class="offcanvas offcanvas-end" tabindex="-1" id="offcanvasRight"
                aria-labelledby="offcanvasRightLabel">
                <div class="offcanvas-header">
                    <h5 class="offcanvas-title" id="offcanvasRightLabel">{{ $t('Filter') }}</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="offcanvas" aria-label="Close"></button>
                </div>
                <div class="offcanvas-body">
                    <div class="mb-3">
                        <label class="form-label">{{ $t('Client') }}</label>
                        <Multiselect mode="tags" :close-on-select="false" v-model="params.client_id" trackBy="name" value="id" label="name" :searchable="true" :options="clients" />
                    </div>
                    <div class="mb-3">
                        <label class="form-label">{{ $t('Co') }}</label>
                        <Multiselect mode="tags" :close-on-select="false" v-model="params.co_id" trackBy="name" value="id" label="name" :searchable="true" :options="coes" />
                    </div>
                    <label class="form-label">{{ $t('Received Date') }}</label>
                    <div class="mb-3 d-flex">
                        <date-picker class="me-1" :range="true" :placeholder="$t('Received Date')" v-model="params.date"
                            valueType="format" format="YYYY-MM-DD"> </date-picker>
                        <button type="button" class="btn border btn-sm text-nowrap py-0" data-bs-toggle="modal" data-bs-target="#modalFilter"><i class="fas fa-sm fa-filter"></i> {{ $t('Filter') }} </button>
                    </div>
                    <div class="list-group mb-3">
                        <button type="button" class="btn btn-success" @click="funGetData"><i class="fa fa-search"></i> {{ $t('Search') }} </button>
                    </div>
                    <div class="list-group mb-3">
                        <button type="button" @click="printP" class="btn btn-primary"><i class="fa fa-print"></i> {{ $t('Print') }}</button>
                    </div>
                    <div class="list-group mb-3">
                        <button type="button" @click="exportExcell" class="btn btn-danger"><i class="fa fa-file-export"></i> {{ $t('Export') }}</button>
                    </div>
                </div>
            </div>
        </div>

        <div slot="body">
            <TabsHeader></TabsHeader>
            <div id="show-print">
                <div class="table-responsive report_print overflow-auto" style="height: calc(100vh - 270px)">
                    <header-report :title="$t('Not Closing Report')" :date="current_date" :type="1" style="display: none;"></header-report>
                    <table class="table table-bordered m-0" id="excel-table">
                        <thead class="text-nowrap fixed_table">
                            <tr>
                                <th>{{ $t("#") }}</th>
                                <th>{{ $t("Client Name") }}</th>
                                <th>{{ $t("CO Name") }}</th>
                                <th>{{ $t("Loan Code") }}</th>
                                <th>{{ $t("Received Date") }}</th>
                                <th>{{ $t("Principal") }}</th>
                                <th>{{ $t("Interest") }}</th>
                                <th>{{ $t("Penalty") }}</th>
                                <th>{{ $t("Total Received") }}</th>
                                <th>{{ $t("Penalty Waiv") }}</th>
                                <th>{{ $t("status") }}</th>
                            </tr>
                        </thead>
                        <tbody class="text-nowrap">
                            <tr v-for="(acc, index) in dataPayments.data" :key="index">
                                <td>{{ index + 1 }}</td>
                                <td>{{ acc.co_name }}</td>
                                <td>{{ acc.client_name }}</td>
                                <td>{{ acc.loan_code }}</td>
                                <td>{{ acc.received_date | onlyDate }}</td>
                                <td>{{ acc.paid_principal | numberFomartValue }}</td>
                                <td>{{ acc.paid_interest | numberFomartValue }}</td>
                                <td>{{ acc.paid_penalty | numberFomartValue }}</td>
                                <td>{{ acc.total_collected | numberFomartValue }}</td>
                                <td>{{ acc.waiv_penalty | numberFomartValue }}</td>
                                <td>
                                    <span v-show="acc.status == 1" class="text-danger"> {{ $t("Pandding") }} </span>
                                    <span v-show="acc.status == 2" class="text-success"> {{ $t("Approved") }} </span>
                                </td>
                            </tr>
                            <tr class="table-active">
                                <td colspan="5" class="text-end">{{ $t("Total") }}</td>
                                <td>{{ totalPrincipal | numberFomartValue }}</td>
                                <td>{{ totalInterest | numberFomartValue }}</td>
                                <td>{{ totalPenalty | numberFomartValue }}</td>
                                <td>{{ totalCollected | numberFomartValue }}</td>
                                <td>{{ totalWaiv | numberFomartValue }}</td>
                                <td></td>
                            </tr>
                        </tbody>
                    </table>
                    <footer-report style="display: none;"></footer-report>
                </div>
            </div>
            <cumstom-pagination :pageShow="true" @PageChange="PageChange($event)" :data="dataPayments" @onChangePage="funGetData($event)"></cumstom-pagination>
        </div>
    </theme-table>
</template>
<script>
import ThemeTable from "../../../components/ThemeTable.vue";
import HeaderReport from "../../../components/report/header.vue";
import FooterReport from "../../../components/report/footer.vue";
import TabsHeader from "./TabsHeader.vue";
import CumstomPagination from "../../../components/CustomPagination.vue";
import { exportTableToExcel } from "../../../exportExcel.js";
export default {
    components: {
        ThemeTable,
        HeaderReport,
        FooterReport,
        TabsHeader,
        CumstomPagination
    }, 
    data() {
        return {

            format: "YYYY-MM-DD",
            dataPayments: { data: [] },
            current_date: new Date().toISOString(),
            clients: [],
            coes: [],
            form: new Form({}),
            params: {
                page: 1,
                per_page: 25,
                search_text: "",

                client_id: [],
                co_id: [],
                date: [],
                deatail: 1,
                loan_status_id: 2,
                client_type: 1,
            },
        };
    },
    created() {
        this.funGetData();
        this.getClient();
        this.getCO();
    },
    methods: {
        async exportExcell() {
            this.$isLoading(true)
            try {
                await exportTableToExcel({
                    tableId: "excel-table",
                    filename: "ExportBorrow",
                    reportTitle: "របាយការណ៍អតិថិជនជំពាក់",
                    subDate: this.params.date,
                })
            } catch (e) {
                this.$toast.warning(e.message);
            } finally {
                this.$isLoading(false)
            }
        },
        printP() {
            this.$htmlToPaper("show-print");
        },
        getClient() {
            axios
                .get("admin-api/com-client")
                .then((res) => {
                    this.clients = res.data;
                })
                .catch((error) => {
                    console.log(error);
                });
        },
        getCO() {
            axios
                .get("admin-api/com-co")
                .then((res) => {
                    this.coes = res.data;
                })
                .catch((error) => {
                    console.log(error);
                });
        },
        funGetData(page = 1) {
            this.params.page = page;
            axios
                .get("admin-api/payment-not-closing-report", {
                    params: this.params,
                })
                .then((res) => {
                    this.dataPayments = res.data;
                })
                .catch((error) => {
                    if (error.message == "Request failed with status code 403") {
                        this.$router.push({ name: "permissionTest" });
                    } else {
                        console.log(error.message);
                    }
                });
        },
        PageChange: function (e) {
            this.params.per_page = e.target.value;
            this.funGetData();
        },

    },
    computed: {
        totalPrincipal: function () {
            var sum = 0;
            this.dataPayments.data.forEach(function (item) {
                sum += parseFloat(item.paid_principal);
            });
            return sum;
        },
        totalInterest: function () {
            var sum = 0;
            this.dataPayments.data.forEach(function (item) {
                sum += parseFloat(item.paid_interest);
            });
            return sum;
        },


        totalCollected: function () {
            var sum = 0;
            this.dataPayments.data.forEach(function (item) {
                sum += parseFloat(item.total_collected);
            });
            return sum;
        },
        totalPenalty: function () {
            var sum = 0;
            this.dataPayments.data.forEach(function (item) {
                sum += parseFloat(item.paid_penalty);
            });
            return sum;
        },
        totalWaiv: function () {
            var sum = 0;
            this.dataPayments.data.forEach(function (item) {
                sum += parseFloat(item.waiv_penalty);
            });
            return sum;
        },
    }
};
</script>
